//+------------------------------------------------------------------+
//|                                     CLOSE PRICE CROSSES OVER EMA |
//|                                                     Duarte Silva |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Duarte Silva"
#property strict

//+------------------------------------------------------------------+
//| Declarao e inicializao de Variveis Externas (Optimizao)   |
//+------------------------------------------------------------------+
//extern bool PriceCrossEMA = false, EMACrossEMA = false, PriceCrossEMAwTrend = false, PriceCrossEMAwLongTrend = true;
extern int EMA_sPeriod = 8; 
extern int EMA_lPeriod = 21;
extern int EMA_vlPeriod = 50;
extern int EMA_Method = 1;

//+------------------------------------------------------------------+
//| Declarao das Variveis Globais da funo                       |
//+------------------------------------------------------------------+
bool LongTrend,ShortTrend, LongOnMarket, ShortOnMarket;
int ticket = 0, PositionIndex = 0, NumSellOrders = 0, NumBuyOrders = 0;
double OrderPrice = 0.0;
double StopLossValue, TakeProfitValue, TrailingStop, Lots;
double ShortEMA, ShortEMA_P, LongEMA, LongEMA_P, VLongEMA, VLongEMA_P;
datetime Lastbar, Curbar; //Open time of last bar   // Open time of current bar
int iMagicNum = 19820506;

//+------------------------------------------------------------------+
//| Inicializao do Expert Adviser                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- Data/hora de abertura da ltima barra
   Lastbar = Time[1];
   
//--- Gerar um  nmero nico para cada par
   if (Symbol() == "EURUSD") iMagicNum= iMagicNum + 1 + Period();
   else if (Symbol() == "USDJPY") iMagicNum= iMagicNum + 2 + Period();
   else if (Symbol() == "GBPUSD") iMagicNum= iMagicNum + 3 + Period();
   else Print ("Nenhum Simbolo Seleccionado");
   
   Print ("Simbolo: ", Symbol(), "Nmero Mgico: ", iMagicNum);
   
//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
   {
   //--- Variveis locais e estticas
   if (NewBarDetection()) //Aes a realizar no incio de cada vela japonesa
      {

      ShortEMA = iMA(NULL,0,EMA_sPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      LongEMA = iMA(NULL,0,EMA_lPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      //VLongEMA = iMA(NULL,0,EMA_vlPeriod,0,MODE_EMA,PRICE_CLOSE,1);
      
      ShortEMA_P = iMA(NULL,0,EMA_sPeriod,0,MODE_EMA,PRICE_CLOSE,2);
      LongEMA_P = iMA(NULL,0,EMA_lPeriod,0,MODE_EMA,PRICE_CLOSE,2);
      //VLongEMA_P = iMA(NULL,0,EMA_vlPeriod,0,MODE_EMA,PRICE_CLOSE,2);
     
      //Event_Detection();
      if(EMA_Method == 1)
      //if(PriceCrossEMA)
        {
         if((Close[2] < LongEMA_P) && (Close[1]> LongEMA))//Close crosses over long EMA
           {
            LongTrend = true;
            ShortTrend = false;
            Print("Tendncia de Subida", NormalizeDouble(Close[2],3), " < ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(Close[1],3), " > ", NormalizeDouble(LongEMA_P,3));
           }
         else if((Close[2] > LongEMA_P) && (Close[1]< LongEMA))//Close crosses under long EMA
           {
            LongTrend = false;
            ShortTrend = true;
            Print("Tendncia de Descida", NormalizeDouble(Close[2],3), " > ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(Close[1],3), " < ", NormalizeDouble(LongEMA_P,3));
           }
         else 
           {
            LongTrend = false;
            ShortTrend = false;
            Print("Tendncia Indefinida");
           }
        }
      if(EMA_Method == 2)
      //if(EMACrossEMA)
        {
         if((ShortEMA_P < LongEMA_P) && (ShortEMA > LongEMA))//Short EMA crosses over Long EMA
           {
            LongTrend = true;
            ShortTrend = false;
            Print("EMA - Tendncia de Subida", NormalizeDouble(ShortEMA_P,3), " < ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(ShortEMA,3), " > ", NormalizeDouble(LongEMA_P,3));
           }
         else if((ShortEMA_P > LongEMA_P) && (ShortEMA< LongEMA))//Short EMA crosses under Long EMA
           {
            LongTrend = false;
            ShortTrend = true;
            Print("EMA - Tendncia de Descida", NormalizeDouble(ShortEMA_P,3), " > ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(ShortEMA,3), " < ", NormalizeDouble(LongEMA_P,3));
           }
         else 
           {
            LongTrend = false;
            ShortTrend = false;
            Print("EMA - Tendncia Indefinida");
           }
        }
      if(EMA_Method == 3)
      //if(PriceCrossEMAwTrend)
        {
         if((Close[2] < LongEMA_P) && (Close[1]> LongEMA) && (LongEMA_P < LongEMA))//Close crosses over long EMA
           {
            LongTrend = true;
            ShortTrend = false;
            Print("Tendncia de Subida", NormalizeDouble(Close[2],3), " < ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(Close[1],3), " > ", NormalizeDouble(LongEMA_P,3));
           }
         else if((Close[2] > LongEMA_P) && (Close[1]< LongEMA)  && (LongEMA_P > LongEMA))//Close crosses under long EMA
           {
            LongTrend = false;
            ShortTrend = true;
            Print("Tendncia de Descida", NormalizeDouble(Close[2],3), " > ", NormalizeDouble(LongEMA_P,3), " && ",NormalizeDouble(Close[1],3), " < ", NormalizeDouble(LongEMA_P,3));
           }
         else 
           {
            LongTrend = false;
            ShortTrend = false;
            Print("Tendncia Indefinida");
           }
        }      

      //Event_Handling();
      if (LongTrend)
         {
         CloseOpenOrders();
         Lots = 0.1;
         BuyLongPosition (Lots);
         if(!ObjectCreate("ARROW BUY Obj: "+TimeToString(Time[0],TIME_DATE|TIME_MINUTES), OBJ_ARROW_UP, 0, Time[0], Low[0] - 0.005))
            {
            Print("Erro: No foi possvel criar Seta Long! code:",GetLastError());
            };
         }
      if (ShortTrend)//&& dStoch_Value < dStoch_Signal
         {
         CloseOpenOrders();
         Lots = 0.1;
         BuyShortPosition (Lots);
         if(!ObjectCreate("ARROW SELL Obj: "+TimeToString(Time[0],TIME_DATE|TIME_MINUTES), OBJ_ARROW_DOWN, 0, Time[0], High[0] + 0.005))
            {
            Print("Erro: No foi possvel criar Seta Sell! code :",GetLastError());
            }
         }

      }   //NewBarDetection

  }
//+------------------------------------------------------------------+
//| Funes Auxiliares                                            |
//+------------------------------------------------------------------+

//--------------------- Detecta abertura de nova barra --------------------------//
bool NewBarDetection()
   { 
   Curbar = Time[1]; // Open time of current bar

   if (Lastbar != Curbar) 
      { 
      Lastbar = Curbar;
      Print("Nova Barra");
      
      NumBuyOrders = 0;
      NumSellOrders = 0;   //Inicializar os contadores
      
      for(PositionIndex= OrdersTotal()-1; PositionIndex >= 0; PositionIndex--)
      {
         if(OrderSelect(PositionIndex, SELECT_BY_POS) && OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol())
         {
            if(OrderType() == OP_BUY)  NumBuyOrders++;
            if(OrderType() == OP_SELL) NumSellOrders++;
         } 
      }         
      Print("Buy Orders: ", NumBuyOrders, "Sell Orders: ", NumSellOrders);
  
      return (true); 
      }
      else return(false);

   }

//--------------------- Efetua a compra de posies longas --------------------------//
void BuyLongPosition(double lots)
   {
   //ticket = OrderSend(Symbol(),OP_BUYLIMIT,lots,Ask-(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Longos",iMagicNum,0,Blue);
   ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,3,0,0,"Compra Longos",iMagicNum,0,Blue);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      LongOnMarket = true;
      ShortOnMarket = false;
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice);
      }
   }
   
//--------------------- Efetua a compra de posies curtas --------------------------//
void BuyShortPosition(double lots)
   {
   //ticket = OrderSend(Symbol(),OP_SELLLIMIT,lots,Bid+(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Curtos",iMagicNum,0,Red);
   ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,3,0,0,"Compra Curtos",iMagicNum,0,Red);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      ShortOnMarket = true;
      LongOnMarket = false;
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice);

      }
   }
//--------------------- Fechar ordens abertas --------------------------//
bool CloseOpenOrders() 
{ 
Print("N de ordens abertas:# ", OrdersTotal()); 

for(PositionIndex = OrdersTotal() - 1; PositionIndex >= 0 ; PositionIndex --)  //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
   {
   if( !OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES) ) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
   
      if ( !OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),3) )
         { 
         Print("Ordem Falhada por Erro:# ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Close failed print some helpful information 
         return (false); 
         }
         else
         {
         Print("Ordem fechada correctamente "); 
         if (LongOnMarket == 1) LongOnMarket = 0;
         if (ShortOnMarket == 1) ShortOnMarket = 0;
         return (true); 
      }
   }
return(0);
}